module Gh
  module Trending
    module Parsers
      # Class indicating that perhaps the HTML of the trending has changed
      # for whatever reason.
      #
      #
      class HtmlChangedError < StandardError
        attr_reader :page_that_changed

        def initialize(page_that_changed, msg = nil)
          @page_that_changed = page_that_changed
          page_changed_human_format = build_human_format_page_changed

          msg ||= 'The page can\'t be crawled anymore because' \
                  "#{page_changed_human_format} changed its HTML format." \
                  'Submit a PR to fix it!'
          super(msg)
        end

        private

        def build_human_format_page_changed
          case page_that_changed
          when :front_page_with_repos
            'the front page that lists all trending repositories'
          when :front_page_with_devs
            'the front page that lists all trending developers'
          else
            error = "Unknown page_that_changed symbol: #{page_that_changed}"
            raise ArgumentError, error
          end
        end
      end
    end
  end
end
