module Gh
  module Trending
    # This class represents a trending repository in the github's trending
    # repositories page.
    class Repository
      attr_reader :name, :description, :language, :period_stars, :url
      # Period stars correspond to the stars that the repository has in the
      # current period being considered, for example: 283 stars THIS WEEK.
      def initialize(
        name: '',
        description: '',
        language: '',
        period_stars: 0,
        url: ''
      )
        @name = name
        @description = description
        @language = language
        @period_stars = period_stars
        @url = url
      end

      def to_h
        {
          name: name,
          description: description,
          language: language,
          period_stars: period_stars,
          url: url
        }
      end
    end
  end
end
